import com.swath.*;
import com.swath.cmd.*;

/**
 * "Grab-Sell/Buy-Dump" script.
 *
 * @author Stein
 * @author Vid Kid
 */
public class GrabSellBuyDump extends UserDefinedScript {
	private Parameter m_planet;
	private Parameter m_type;
	private Parameter m_type2;
	private Parameter m_different;
	private Parameter m_port;
	private Parameter m_buy;
        private Parameter m_sell;

	public String getName() {
		return "Grab-Sell/Buy-Dump";
	}

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.COMMAND_PROMPT)) return false;

		m_sell=new Parameter("Sell product ?");
		m_sell.setBoolean(true);
		m_planet = new Parameter("Grab from planet");
		m_planet.setType(Parameter.INTEGER);
		m_type = new Parameter("Type of product to grab and sell");
		m_type.setType(Parameter.CHOICE);
		m_type.addChoice(Swath.FUEL_ORE, "Fuel Ore");
		m_type.addChoice(Swath.ORGANICS, "Organics");
		m_type.addChoice(Swath.EQUIPMENT, "Equipment");
		m_type.setCurrentChoice(Swath.EQUIPMENT);
		m_buy=new Parameter("Buy product too ?");
		m_buy.setBoolean(false);
		m_type2 = new Parameter("Type of product to buy and dump");
		m_type2.setType(Parameter.CHOICE);
		m_type2.addChoice(Swath.FUEL_ORE, "Fuel Ore");
		m_type2.addChoice(Swath.ORGANICS, "Organics");
		m_type2.addChoice(Swath.EQUIPMENT, "Equipment");
		m_type2.setCurrentChoice(Swath.FUEL_ORE);
		m_different = new Parameter("Different sector port ?");
		m_different.setBoolean(false);
		m_port = new Parameter("Which sector ?");
		m_port.setType(Parameter.INTEGER);

                registerParam(m_sell);
		registerParam(m_planet);
		registerParam(m_type);
		registerParam(m_buy);
		registerParam(m_type2);
		registerParam(m_different);
		registerParam(m_port);

		return true;
	}

	public boolean runScript() throws Exception {
		int fuel=0;
		int org=0;
		int equip=0;
		int fuelB=0;
		int orgB=0;
		int equipB=0;
		int holds = Swath.ship.holds();
		int currSec = Swath.main.currSector();
		int i=0;


		while (true) {
			// Reset all numbers to 0
			fuel=0;
			org=0;
			equip=0;
			fuelB=0;
			orgB=0;
			equipB=0;


			switch (m_type.getCurrentChoice()) {
				case Swath.FUEL_ORE:
					fuel=holds;
					break;
				case Swath.ORGANICS:
					org=holds;
					break;
				case Swath.EQUIPMENT:
					equip=holds;
					break;
			}

			if (m_buy.getBoolean()) {
				switch (m_type2.getCurrentChoice()) {
					case Swath.FUEL_ORE:
						fuelB=holds;
						break;
					case Swath.ORGANICS:
						orgB=holds;
						break;
					case Swath.EQUIPMENT:
						equipB=holds;
						break;
				}
			}

			// Land On Planet
//			PrintText.exec("\r\n\r\n----------- Run Number "+i+" -----------");

			Land.exec(m_planet.getInteger());
			// If they bought
			if (m_buy.getBoolean() && (i != 0)) {
				// Leave product
				TakeLeaveProducts.exec(-fuelB,-orgB,-equipB);
//				PrintText.exec("\r\n\r\nTakeLeaveProducts.exec(-"+fuelB+",-"+orgB+",-"+equipB+");");

			}

			// Take Product
			TakeLeaveProducts.exec(fuel,org,equip);
//			PrintText.exec("\r\n\r\nTakeLeaveProducts.exec("+fuel+","+org+","+equip+");");
			// Leave Planet
			LiftOff.exec();

			// If port is in different sector
			if (m_different.getBoolean()) {
				// Move there
				Move.exec(m_port.getInteger());
			}

			// Sell or buy
			if (fuel==0) { fuel=-fuelB; }
			if (org==0) { org=-orgB; }
			if (equip==0) { equip=-equipB; }
			Trade.exec(-fuel,-org,-equip);
//			PrintText.exec("\r\n\r\nTrade.exec(-"+fuel+",-"+org+",-"+equip+");");

			// If they bought
//			if (m_buy.getBoolean()){
				// Buy
//				Trade.exec(fuelB,orgB,equipB);
//				PrintText.exec("\r\n\r\nTrade.exec("+fuelB+","+orgB+","+equipB+");");

//			}
			// If the port was in a different sector
			if (m_different.getBoolean()) {
				// Move back to planet
				Move.exec(currSec);
			}
			i++;
		}
	}
}
